#define BSPD 3

drawPaddle1:
	push hl
	ld hl, 10
	ld (_window_x1), hl
	ld hl, 10
	ld de, (paddle1width)
	add hl, de
	ld (_window_x2), hl
	ld hl, (paddle1y)
	ld (_window_y1), hl
	ld de, (paddle1height)
	add hl, de
	ld (_window_y2), hl
	call setWindow
	pop hl
	call fillWindow
	ret

drawPaddle2:
	push hl
	ld hl, 319-25
	ld (_window_x1), hl
	ld hl, 319-25
	ld de, (paddle2width)
	add hl, de
	ld (_window_x2), hl
	ld hl, (paddle2y)
	ld (_window_y1), hl
	ld de, (paddle2height)
	add hl, de
	ld (_window_y2), hl
	call setWindow
	pop hl
	call fillWindow
	ret

moveDown:

	ld hl, (paddle1y)
	ld de, (paddle1height)
	add hl, de

	push hl
	ld hl, 239
	ld de, (paddle1speed)
	ld a, 0
	cp 0
	sbc hl, de
	ld d, h
	ld e, l
	pop hl

	ld a, l
	cp e
	jp c, moveDownStart
	jp nz, moveDownSnap

	ld a, h
	cp d
	jp c, moveDownStart
	jp moveDownSnap 

moveDownStart:
	ld hl, (paddle1y)
	ld de, (paddle1speed)
	add hl, de
	ld (paddle1y), hl

	ld a, 0
	cp 0
	ld hl, 10
	ld (_window_x1), hl
	ld hl, 10
	ld de, (paddle1width)
	add hl, de
	ld (_window_x2), hl
	ld hl, (paddle1y)
	ld de, (paddle1speed)
	sbc hl, de
	ld (_window_y1), hl
	add hl, de
	ld (_window_y2), hl
	call setWindow
	ld hl, (bgcolor)
	call fillWindow

	ret
moveDownSnap:
	ld de, (paddle1height)
	ld hl, 239
	ld a, 0
	cp 0
	sbc hl, de
	ld (paddle1y), hl

	ld a, 0
	cp 0
	ld hl, 10
	ld (_window_x1), hl
	ld hl, 10
	ld de, (paddle1width)
	add hl, de
	ld (_window_x2), hl
	ld hl, (paddle1y)
	ld de, (paddle1speed)
	sbc hl, de
	ld (_window_y1), hl
	add hl, de
	ld (_window_y2), hl
	call setWindow
	ld hl, (bgcolor)
	call fillWindow

	ret

moveUp:

	ld hl, (paddle1y)
	ld de, (paddle1speed)

	ld a, l
	cp e
	jp c, moveUpSnap
	jp nz, moveUpStart

	ld a, h
	cp d
	jp c, moveUpSnap
	
moveUpStart:

	ld a, 0
	cp 0
	ld hl, (paddle1y)
	ld de, (paddle1speed)
	sbc hl, de
	ld (paddle1y), hl

	ld hl, 10
	ld (_window_x1), hl
	ld hl, 10
	ld de, (paddle1width)
	add hl, de
	ld (_window_x2), hl
	ld hl, (paddle1y)
	ld de, (paddle1height)
	add hl, de
	ld de, (paddle1speed)
	ld (_window_y1), hl
	add hl, de
	ld (_window_y2), hl
	call setWindow
	ld hl, (bgcolor)
	call fillWindow

	ret
moveUpSnap:
	ld hl, 0
	ld (paddle1y), hl

	ld hl, 10
	ld (_window_x1), hl
	ld hl, 10
	ld de, (paddle1width)
	add hl, de
	ld (_window_x2), hl
	ld hl, (paddle1y)
	ld de, (paddle1height)
	add hl, de
	ld de, (paddle1speed)
	ld (_window_y1), hl
	add hl, de
	ld (_window_y2), hl
	call setWindow
	ld hl, (bgcolor)
	call fillWindow

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

moveDown2:

	ld hl, (paddle2y)
	ld de, (paddle2height)
	add hl, de

	push hl
	ld hl, 239
	ld de, (paddle2speed)
	ld a, 0
	cp 0
	sbc hl, de
	ld d, h
	ld e, l
	pop hl

	ld a, l
	cp e
	jp c, moveDown2Start
	jp nz, moveDown2Snap

	ld a, h
	cp d
	jp c, moveDown2Start
	jp moveDown2Snap 

moveDown2Start:
	ld hl, (paddle2y)
	ld de, (paddle2speed)
	add hl, de
	ld (paddle2y), hl

	ld a, 0
	cp 0
	ld hl, 319-25
	ld (_window_x1), hl
	ld hl, 319-25
	ld de, (paddle2width)
	add hl, de
	ld (_window_x2), hl
	ld hl, (paddle2y)
	ld de, (paddle2speed)
	sbc hl, de
	ld (_window_y1), hl
	add hl, de
	ld (_window_y2), hl
	call setWindow
	ld hl, (bgcolor)
	call fillWindow

	ret
moveDown2Snap:
	ld de, (paddle2height)
	ld hl, 239
	ld a, 0
	cp 0
	sbc hl, de
	ld (paddle2y), hl

	ld a, 0
	cp 0
	ld hl, 319-25
	ld (_window_x1), hl
	ld hl, 319-25
	ld de, (paddle2width)
	add hl, de
	ld (_window_x2), hl
	ld hl, (paddle2y)
	ld de, (paddle2speed)
	sbc hl, de
	ld (_window_y1), hl
	add hl, de
	ld (_window_y2), hl
	call setWindow
	ld hl, (bgcolor)
	call fillWindow

	ret

moveUp2:

	ld hl, (paddle2y)
	ld de, (paddle2speed)

	ld a, l
	cp e
	jp c, moveUp2Snap
	jp nz, moveUp2Start

	ld a, h
	cp d
	jp c, moveUp2Snap
	
moveUp2Start:

	ld a, 0
	cp 0
	ld hl, (paddle2y)
	ld de, (paddle2speed)
	sbc hl, de
	ld (paddle2y), hl

	ld hl, 319-25
	ld (_window_x1), hl
	ld hl, 319-25
	ld de, (paddle2width)
	add hl, de
	ld (_window_x2), hl
	ld hl, (paddle2y)
	ld de, (paddle2height)
	add hl, de
	ld de, (paddle2speed)
	ld (_window_y1), hl
	add hl, de
	ld (_window_y2), hl
	call setWindow
	ld hl, (bgcolor)
	call fillWindow

	ret
moveUp2Snap:
	ld hl, 0
	ld (paddle2y), hl

	ld hl, 319-25
	ld (_window_x1), hl
	ld hl, 319-25
	ld de, (paddle2width)
	add hl, de
	ld (_window_x2), hl
	ld hl, (paddle2y)
	ld de, (paddle2height)
	add hl, de
	ld de, (paddle2speed)
	ld (_window_y1), hl
	add hl, de
	ld (_window_y2), hl
	call setWindow
	ld hl, (bgcolor)
	call fillWindow

	ret

moveCPU:
	;hl = bally + ballheight/2
	ld hl, (ballheight)
	ld a, 2
	bcall(_DivHLByA)
	ld de, (bally)
	add hl, de
	push hl

	;de = paddle2y + paddle2height/2
	ld hl, (paddle2height)
	ld a, 2
	bcall(_DivHLByA)
	ld de, (paddle2y)
	add hl, de
	ld d, h
	ld e, l
	pop hl

	ld bc, (paddle2speed)
	ld a, (hard)
	cp 1
	jp z, skipvibrateadjust1
	sbc hl, bc
	sbc hl, bc
skipvibrateadjust1:
	call cpHLDE
	jp c, _dontMoveCPUDown
	
_moveCPUDown:
	ld de, 240
	call cpHLDE
	ret nc

	call moveDown2
	ret

_dontMoveCPUDown:
	ld a, 0
	cp 0
	ld bc, (paddle2speed)
	ld a, (hard)
	cp 1
	jp z, skipvibrateadjust2
skipvibrateadjust2:
	add hl, bc	
	add hl, bc
	call cpHLDE
	ret nc

	call moveUp2
	ret

	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


drawBall:
	push hl
	ld hl, (ballx)
	ld (_window_x1), hl
	ld de, (ballwidth)
	add hl, de
	ld (_window_x2), hl
	ld hl, (bally)
	ld (_window_y1), hl
	ld de, (ballheight)
	add hl, de
	ld (_window_y2), hl
	call setWindow
	pop hl
	call fillWindow
	ret

moveBall:


	ld a, (shouldClearBall)
	cp 1
	jp nz, _dontClearBall

	ld hl, (bgcolor)
	call drawBall

_dontClearBall:

	ld hl, (ballx)
	ld de, 160
	call cpHLDE
	jp c, sideon1
	ld a, 0
	ld (sideon), a
	jp skipsideon1
sideon1:
	ld a, 1
	ld (sideon), a
skipsideon1:

	ld a, 1
	ld (shouldClearBall), a
	
	ld hl, (ballx)
	ld de, (ballvelocityx)
	add hl, de
	ld (ballx), hl

	ld hl, (bally)
	ld de, (ballvelocityy)
	add hl, de
	ld (bally), hl

	;check if ball is outside 
	;only if de > hl
	ld hl, 319
	ld de, (ballwidth)
	ld a, 0
	cp 0
	sbc hl, de
	ld de, (ballx)

	ld a, d
	cp h
	jp c, _dontResetBall
	jp nz, resetBall
	
	ld a, e
	cp l
	jp c, _dontResetBall
	jp nz, resetBall

	;only if hl < de
	ld de, 0
	ld hl, (ballx)

;	ld a, l
;	cp e
;	jp c, resetBall
;	jp nz, _dontResetBall
;	ld a, h	
;	cp d
;	jp c, resetBall
;	jp z, resetBall
;;;;;;;;;;;;;;;;;;;;;;;;;;;
_dontResetBall:

	;check if ball is outside 
	;top or bottom of the screen
	;invert y velocity?
	;only if hl <= de
	ld hl, 239
	ld de, (ballheight)
	ld a, 0
	cp 0
	sbc hl, de
	ld de, (bally)
	call cpHLDE
	jp c, invertVelocityY
	jp z, invertVelocityY

	;only if hl <= de
	ld de, 0
	ld hl, (bally)
	call cpHLDE
	jp c, invertVelocityY
	jp z, invertVelocityY

_dontInvertVelocityY:

	call checkPaddle1Collide
	call checkPaddle2Collide

	ld hl, (fgcolor)
	call drawBall

	ret


invertVelocityY:

	ld a, 0
	cp 0
	ld hl, (ballvelocityy)
	ld de, (ballvelocityy)
	sbc hl, de
	sbc hl, de

	ld (ballvelocityy), hl

	call beepNoise1

	ld a, 0
	ld (shouldClearBall), a
	
	ret

invertVelocityX:

	ld a, 0
	cp 0
	ld hl, (ballvelocityx)
	ld de, (ballvelocityx)
	sbc hl, de
	sbc hl, de
	ld a, 200
	cp h
	jp c, player2Adjustment
	inc hl
	
	;player 1 adjustment
	push hl

	ld hl, (paddle1height)
	ld a, 2
	bcall(_DivHLByA)
	ld de, (paddle1y)
	add hl, de
	ld a, BSPD
	bcall(_DivHLByA)
	ld b, h
	ld c, l

	ld hl, (ballheight)
	ld a, 2
	bcall(_DivHLByA)
	ld de, (bally)
	add hl, de
	ld a, BSPD
	bcall(_DivHLByA)

	ld a, 5
	cp 5
	sbc hl, bc

;	ld de, (ballvelocityy)
;	add hl, de
	ld (ballvelocityy), hl

	pop hl


	jp skipPlayer2Adjustment
player2Adjustment:
	dec hl

	;player 2 adjustment
	push hl

	ld hl, (paddle2height)
	ld a, 2
	bcall(_DivHLByA)
	ld de, (paddle2y)
	add hl, de
	ld a, BSPD
	bcall(_DivHLByA)
	ld b, h
	ld c, l

	ld hl, (ballheight)
	ld a, 2
	bcall(_DivHLByA)
	ld de, (bally)
	add hl, de
	ld a, BSPD
	bcall(_DivHLByA)

	ld a, 5
	cp 5
	sbc hl, bc

;	ld de, (ballvelocityy)
;	add hl, de
	ld (ballvelocityy), hl

	pop hl

skipPlayer2Adjustment:

	ld (ballvelocityx), hl

	ld a, 1
	ld (shouldClearBall), a
	
	ret

resetBall:

	ld a, (sideon)
	cp 0
	jp z, incfirstplayer
	call incpaddle2points
	jp skipincfirstplayer
incfirstplayer:
	call incpaddle1points
skipincfirstplayer:

	call moveBallCenter
	ld a, 0
	ld (shouldClearBall), a
	ld hl, 3
	ld (ballvelocityx), hl
	ld hl, 5
	ld (ballvelocityy), hl
	call beepNoise3
	ret

incpaddle2points:
	ld a, (paddle2points)
	inc a
	cp 10
	jp nz, _incpaddle2points_dontreset
	ld a, 0
_incpaddle2points_dontreset:
	ld (paddle2points), a
	cp 0
	call z, getSprite0Addr
	cp 1
	call z, getSprite1Addr
	cp 2
	call z, getSprite2Addr
	cp 3
	call z, getSprite3Addr
	cp 4
	call z, getSprite4Addr
	cp 5
	call z, getSprite5Addr
	cp 6
	call z, getSprite6Addr
	cp 7
	call z, getSprite7Addr
	cp 8
	call z, getSprite8Addr
	cp 9
	call z, getSprite9Addr
	ld (paddle2pointsaddr), hl
	ret
incpaddle1points:
	ld a, (paddle1points)
	inc a
	cp 10
	jp nz, _incpaddle1points_dontreset
	ld a, 0
_incpaddle1points_dontreset:
	ld (paddle1points), a
	cp 0
	call z, getSprite0Addr
	cp 1
	call z, getSprite1Addr
	cp 2
	call z, getSprite2Addr
	cp 3
	call z, getSprite3Addr
	cp 4
	call z, getSprite4Addr
	cp 5
	call z, getSprite5Addr
	cp 6
	call z, getSprite6Addr
	cp 7
	call z, getSprite7Addr
	cp 8
	call z, getSprite8Addr
	cp 9
	call z, getSprite9Addr
	ld (paddle1pointsaddr), hl
	ret

getSprite0Addr:
	ld hl, IMG0
	ret
getSprite1Addr:
	ld hl, IMG1
	ret
getSprite2Addr:
	ld hl, IMG2
	ret
getSprite3Addr:
	ld hl, IMG3
	ret
getSprite4Addr:
	ld hl, IMG4
	ret
getSprite5Addr:
	ld hl, IMG5
	ret
getSprite6Addr:
	ld hl, IMG6
	ret
getSprite7Addr:
	ld hl, IMG7
	ret
getSprite8Addr:
	ld hl, IMG8
	ret
getSprite9Addr:
	ld hl, IMG9
	ret

cpHLDE:
	ld a, h
	cp d
	jp nz, _notEqual
	ld a, l
	cp e
	jp nz, _notEqual
	ld a, 0
	cp 0
	ret
_notEqual:
	ld a, h
	cp d
	jp c, _lessThan
	jp nz, _notLessThan			
	ld a, l
	cp e
	jp c, _lessThan
	jp _notLessThan
	ret
_lessThan:
	ld a, 1
	cp 2
	ret

_notLessThan:
	ld a, 2
	cp 1

	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
drawDivider:
	push hl
	ld hl, 160-1
	ld (_window_x1), hl
	ld hl, 160+1
	ld (_window_x2), hl
	ld hl, 0
	ld (_window_y1), hl
	ld hl, 239
	ld (_window_y2), hl
	call setWindow
	pop hl
	call fillWindow

	ret
moveBallCenter:
	ld hl, (ballheight)
	ld a, 2
	bcall(_DivHLByA)
	ld d, h
	ld e, l
	ld hl, 120
	sbc hl, de
	ld (bally), hl

	ld hl, (ballwidth)
	ld a, 2
	bcall(_DivHLByA)
	ld d, h
	ld e, l
	ld hl, 160
	sbc hl, de
	ld (ballx), hl
	ret

checkPaddle1Collide:
	ld a, (ballvelocityx)
	cp 200
	ret c

	ld hl, 10
	ld de, (paddle1width)
	add hl, de
	ld d, h
	ld e, l
	ld hl, (ballx)
	call cpHLDE
	ret nc

	ld hl, (paddle1y)
	ld de, (paddle1height)
	add hl, de
	ld de, (bally)
	call cpHLDE
	ret c

	ld hl, (bally)
	ld de, (ballheight)
	add hl, de
	ld de, (paddle1y)
	call cpHLDE
	ret c

	ld hl, (ballx)
	ld de, (ballwidth)
	add hl, de
	ld de, 15
	call cpHLDE
	ret c

	call beepNoise2
	jp invertVelocityX


checkPaddle2Collide:
	ld a, (ballvelocityx)
	cp 200
	ret nc

	ld hl, (ballx)
	ld de, (ballwidth)
	add hl, de
	ld de, 319-25
	call cpHLDE
	ret c

	ld hl, (paddle2y)
	ld de, (paddle2height)
	add hl, de
	ld de, (bally)
	call cpHLDE
	ret c

	ld hl, (bally)
	ld de, (ballheight)
	add hl, de
	ld de, (paddle2y)
	call cpHLDE
	ret c


	ld hl, (ballx)
	ld de, (ballwidth)
	add hl, de
	ld de, 319-10
	ret c

	call beepNoise2
	jp invertVelocityX


dontInvertVelocityX:
	ret

shouldClearBall:
	.db 1
ballwidth:
	.dw 10
ballheight:
	.dw 10
ballvelocityy:
	.dw 5
ballvelocityx:
	.dw 3
ballx:
	.dw 100
bally:
	.dw 50
paddle1y:
	.dw 120-30
paddle1speed:
	.dw 10
paddle1height:
	.dw 60
paddle1width:
	.dw 15
paddle1pointsaddr:
	.dw 0
paddle1points:
	.db 0
paddle2y:
	.dw 120-30
paddle2speed:
	.dw 10
paddle2height:
	.dw 60
paddle2width:
	.dw 15
paddle2pointsaddr:
	.dw 0
paddle2points:
	.db 0
sideon:
	.db 0
fgcolor:
	.dw $FFFF
bgcolor:
	.dw $0000
